"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

exports.default = addPage;

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _path = require("path");

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

var _mkdirp = require("mkdirp");

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _fileExists = require("../fileExists");

var _fileExists2 = _interopRequireDefault(_fileExists);

var _ConfigurationError = require("../ConfigurationError");

var _ConfigurationError2 = _interopRequireDefault(_ConfigurationError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PAGE_SOURCE = _lodash2.default.template("\nimport React from \"react\";\n\nexport default class <%= className %> {\n\thandleRoute(next) {\n\t\t// Kick off data requests here.\n\t\treturn next();\n\t}\n\n\tgetElements() {\n\t\treturn <div>This is <%= className %>.</div>\n\t}\n}\n");

function addPage(options) {
	var routesFile = options.routesFile,
	    routesPath = options.routesPath,
	    routes = options.routes;


	var path = options._[3];
	var className = options._[4];

	if (!path || !className) {
		throw new _ConfigurationError2.default("Usage: react-server add-page <urlPath> <ClassName>");
	}

	var page = (0, _path.join)("pages", className + ".js");

	if ((0, _fileExists2.default)(page)) {
		throw new _ConfigurationError2.default("Found a pre-existing " + page + ".  Aborting.");
	}

	(0, _mkdirp2.default)("pages");

	console.log(_chalk2.default.yellow("Generating " + page));

	_fs2.default.writeFileSync(page, PAGE_SOURCE({ className: className }));

	routes.routes[className] = { path: path, page: page };

	console.log(_chalk2.default.yellow("Updating " + routesFile));

	_fs2.default.writeFileSync(routesPath, (0, _stringify2.default)(routes, null, "  ") + "\n");

	console.log(_chalk2.default.green("All set!"));
}
module.exports = exports["default"];