"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = compile;

var _compileClient2 = require("../compileClient");

var _compileClient3 = _interopRequireDefault(_compileClient2);

var _handleCompilationErrors = require("../handleCompilationErrors");

var _handleCompilationErrors2 = _interopRequireDefault(_handleCompilationErrors);

var _setupLogging = require("../setupLogging");

var _setupLogging2 = _interopRequireDefault(_setupLogging);

var _logProductionWarnings = require("../logProductionWarnings");

var _logProductionWarnings2 = _interopRequireDefault(_logProductionWarnings);

var _reactServer = require("../react-server");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var logger = _reactServer.logging.getLogger({ "name": "react-server-cli.src.commands.compile", "color": { "server": 63, "client": "rgb(42,42,212)" } });

function compile(options) {
	(0, _setupLogging2.default)(options);
	(0, _logProductionWarnings2.default)(options);

	var _compileClient = (0, _compileClient3.default)(options),
	    compiler = _compileClient.compiler;

	logger.notice("Starting compilation of client JavaScript...");
	compiler.run(function (err, stats) {
		var error = (0, _handleCompilationErrors2.default)(err, stats);
		if (!error) {
			logger.notice("Successfully compiled client JavaScript.");
		} else {
			logger.error(error);
		}
	});
}
module.exports = exports["default"];