"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

exports.default = init;

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _child_process = require("child_process");

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

var _fileExists = require("../fileExists");

var _fileExists2 = _interopRequireDefault(_fileExists);

var _ConfigurationError = require("../ConfigurationError");

var _ConfigurationError2 = _interopRequireDefault(_ConfigurationError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEPENDENCIES = ["react-server", "babel-preset-react-server",

// TODO: Modernize our peer deps and remove versions here.
"react@^15.4.1", "react-dom@^15.4.1", "superagent@1.8.4"];

var CONFIG = {
	"routes.json": {
		middleware: [],
		routes: {}
	},
	".reactserverrc": {
		routesFile: "routes.json",
		port: 3000,
		env: {
			production: {
				port: 80
			}
		}
	},
	".babelrc": {
		presets: ["react-server"]
	}
};

function init() {

	if (!(0, _fileExists2.default)("package.json")) {
		console.log(_chalk2.default.yellow("No package.json found.  Running `npm init --yes`"));
		(0, _child_process.spawnSync)("npm", ["init", "--yes"], { stdio: "inherit" });
	}

	(0, _keys2.default)(CONFIG).forEach(function (fn) {
		if ((0, _fileExists2.default)(fn)) {
			throw new _ConfigurationError2.default("Found a pre-existing " + fn + ".  Aborting.");
		}
	});

	console.log(_chalk2.default.yellow("Installing dependencies"));

	(0, _child_process.spawnSync)("npm", ["install", "--save"].concat(DEPENDENCIES), { stdio: "inherit" });

	console.log(_chalk2.default.yellow("Installing devDependencies"));

	_lodash2.default.forEach(CONFIG, function (config, fn) {
		console.log(_chalk2.default.yellow("Generating " + fn));

		_fs2.default.writeFileSync(fn, (0, _stringify2.default)(config, null, "  ") + "\n");
	});

	console.log(_chalk2.default.green("All set!"));
}
module.exports = exports["default"];