"use strict";

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = require('fs');
var run = require("./run");
var parseCliArgs = require("./parseCliArgs");
var defaultOptions = require("./defaultOptions");

require.extensions['.css'] = require.extensions['.less'] = require.extensions['.scss'] = require.extensions['.sass'] = function (module, filename) {
	return module._compile("", filename);
};

require.extensions['.html'] = require.extensions['.md'] = function (module, filename) {
	var text = fs.readFileSync(filename, { encoding: 'utf-8' });
	return module._compile("module.exports = " + (0, _stringify2.default)(text), filename);
};

module.exports = {
	parseCliArgs: parseCliArgs,
	run: run,
	defaultOptions: defaultOptions
};